%bcond_with dietlibc
%bcond_with test

Summary:       Tool for creating supermin appliances
Name:          supermin
Version:       5.3.3
Release:       8%{?dist}
URL:           https://people.redhat.com/~rjones/supermin/
License:       GPLv2+

Source0:       http://download.libguestfs.org/supermin/5.3-development/%{name}-%{version}.tar.gz
Source1:       supermin.attr
Source2:       supermin-find-requires

Patch3000:     0002-Add-support-for-OCaml-5.0.patch
Patch3001:     0003-Restore-compatibility-with-OCaml-4.07.patch

Patch5000:     support-opencloudos.patch

BuildRequires: grubby systemd-udev kernel-srpm-macros
BuildRequires: ocaml ocaml-findlib-devel
BuildRequires: /usr/sbin/mke2fs e2fsprogs-devel findutils
BuildRequires: /usr/bin/pod2html rpm rpm-devel dnf dnf-plugins-core
BuildRequires: gcc make autoconf, automake /usr/bin/pod2man

%if %{with test}
BuildRequires: augeas hivex kernel tar
%endif

%if %{with dietlibc}
BuildRequires: dietlibc-devel
%else
BuildRequires: glibc-static
%endif

Requires: rpm util-linux-ng cpio tar /usr/sbin/mke2fs e2fsprogs-libs >= 1.42

ExclusiveArch: x86_64 aarch64 riscv64 loongarch64
ExcludeArch:   ppc64le

%description
Supermin is a tool for building supermin appliances.  These are tiny
appliances (similar to virtual machines), usually around 100KB in
size, which get fully instantiated on-the-fly in a fraction of a
second when you need to boot one of them.

Note that if you want to run 'supermin --prepare' you will need the
extra dependencies provided by %{name}-devel.


%package devel
Summary:       Development tools for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      rpm-build
Requires:      dnf
Requires:      dnf-plugins-core
Requires:      findutils


%description devel
%{name}-devel contains development tools for %{name}.

It contains extra dependencies needed for 'supermin --prepare' to
work, as well as tools for automatic RPM dependency generation from
supermin appliances.


%prep
%autosetup -p1


%build
autoreconf -fiv
%configure --disable-network-tests

%if %{with dietlibc}
make -C init CC="diet gcc"
%endif
%make_build


%install
%make_install

mkdir -p %{buildroot}%{_rpmconfigdir}/fileattrs/
install -m 0644 %{SOURCE1} %{buildroot}%{_rpmconfigdir}/fileattrs/
install -m 0755 %{SOURCE2} %{buildroot}%{_rpmconfigdir}/

%if %{with test}
%check
make check || {
    cat tests/test-suite.log
    exit 1
}
%endif


%files
%license COPYING
%doc README examples/build-basic-vm.sh
%{_bindir}/supermin
%{_mandir}/man1/supermin.1*


%files devel
%{_rpmconfigdir}/fileattrs/supermin.attr
%{_rpmconfigdir}/supermin-find-requires


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.3-8
- Rebuilt for loongarch release

* Tue Jul 9 2024 Pengda Dou <doupengda@loongson.cn> - 5.3.3-7
- [Type] other
- [DESC] add support for loongarch64

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.3-6
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 10 2023 Shuo Wang <abushwang@tencent.com> - 5.3.3-5
- add support for OCaml 5.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.3-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.3-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 29 2023 cunshunxia <cunshunxia@tencent.com> - 5.3.3-2
- support opencloudos.

* Mon Mar 20 2023 cunshunxia <cunshunxia@tencent.com> - 5.3.3-1
- initial build
